"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTailwindComponent = void 0;
var react_1 = __importStar(require("react"));
var classnames_1 = require("../utils/classnames");
var createTailwindComponent = function (_, component, strings, tags) {
    var includesFunctionTags = tags.some(function (tag) { return typeof tag === "function"; });
    var preCompiledClassnames = !includesFunctionTags
        ? (0, classnames_1.compileClassNames)(strings.raw, tags, {})
        : "";
    var twComponent = react_1.default.forwardRef(function (props, ref) {
        var classnames = (0, react_1.useMemo)(function () {
            if (includesFunctionTags) {
                return (0, classnames_1.compileClassNames)((props.tw ? __spreadArray(__spreadArray([], strings.raw, true), [props.tw], false) : strings.raw), tags, props);
            }
            return preCompiledClassnames;
        }, [props]);
        return react_1.default.createElement(component, __assign(__assign({}, props), { ref: ref, dataSet: { tw: classnames } }));
    });
    return twComponent;
};
exports.createTailwindComponent = createTailwindComponent;
