"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compileClassNames = void 0;
var compileClassNames = function (strings, tags, props) {
    var classnames = strings.map(function (string) {
        return string.replaceAll("\n", "").trim();
    });
    var missingStringIndexes = [];
    classnames.forEach(function (string, idx) {
        if (string === "") {
            missingStringIndexes.push(idx);
        }
        else {
            classnames[idx] = classnames[idx].trim();
        }
    });
    missingStringIndexes.forEach(function (missingIndex, idx) {
        var tag = tags[idx];
        if (tag) {
            if (Array.isArray(tag)) {
                // Tag is array of strings
                classnames[missingIndex] = tag.join(" ");
            }
            if (typeof tag === "function") {
                var tagResult = tag(props);
                classnames[missingIndex] = Array.isArray(tagResult)
                    ? tagResult.join(" ")
                    : tagResult;
            }
            if (typeof tag === "string") {
                classnames[missingIndex] = tag;
            }
        }
    });
    return classnames.join(" ");
};
exports.compileClassNames = compileClassNames;
